<?php
/**
*
* @package jQ User Weather v.0.0.2 / #fix1 reported by Jane Doe
* @version $Id: user_weather.php 2356 2012-03-07 00:50:32Z 4seven $
* @copyright (c) 2012 / 4seven
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : '../';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);

$user->session_begin();
$auth->acl($user->data);
$user->setup();

page_header('User Weather');

if ($auth->acl_get('u_viewprofile'))
{

$user_profile_id = request_var('user_id', 0);

//load config file, for later structuring
if (!isset($add_map))
{
include($phpbb_root_path . 'user_weather/user_weather_config.' . $phpEx);
}

		// get user map
		$sql = 'SELECT user_map_location
                FROM ' . USERS_TABLE . '
		        WHERE user_id = ' . $user_profile_id;
        $result = $db->sql_query($sql);
		$row = $db->sql_fetchrow($result);
        $db->sql_freeresult($result);

// only if present
if ($row['user_map_location'] !== 0)
{

	$profile_fields_town = str_replace('_', ' ', $row['user_map_location']);

	$template->assign_var('S_USER_MAP_TRUE',true);

/*
Base Author: Sebastian Gollus
Modified, build cache, set for phpbb3: 4seven 
BEGIN Version: 1.0.201106 (B)
*/

$script_pathes = $config['script_path'] . '/user_weather';

function website_wetter($plz='', $ort='', $land='', $sprache='', $icons_src = '')
{

global $script_pathes;


	$icons_google = $script_pathes;
	
	if($ort != '')
	{
		$station = $ort;
	}
	else
	{
		$station = $plz . '_' . $land;
	}

// cache thing
$user_profile_id = request_var('user_id', 0);	

$file = 'cache/'. $station . '_' .  $sprache . '_' . $user_profile_id .  '.xml';

$interval = 60 * 60 * 1;

if (file_exists($file) && (filectime($file) + $interval > time())) {
$content = file_get_contents($file);

}

else{

$request = file_get_contents('http://www.google.com/ig/api?weather='.$station.'&hl='.$sprache);

if(!$request){

$content = file_get_contents($file); }

else{
$content = $request; 
$writeres = file_put_contents($file,$content); } 

}
// cache thing

$api = simplexml_load_string(utf8_encode($content));

	$wetter = array();

	$wetter['datum'] = @$api->weather->forecast_information->forecast_date->attributes()->data;
	$wetter['zeit'] = @$api->weather->forecast_information->current_date_time->attributes()->data;
	$wetter[0]['zustand'] = @$api->weather->current_conditions->condition->attributes()->data;
	$wetter[0]['temperatur'] = @$api->weather->current_conditions->temp_f->attributes()->data;
	$wetter[0]['luftfeuchtigkeit'] = @$api->weather->current_conditions->humidity->attributes()->data;
	$wetter[0]['wind'] = @$api->weather->current_conditions->wind_condition->attributes()->data;
	$wetter[0]['icon'] = @str_replace($icons_google, $icons_src, $api->weather->current_conditions->icon->attributes()->data);
	
	$i = 1;

	foreach($api->weather->forecast_conditions as $weather)
	{

	
		$wetter[$i]['wochentag'] = @$weather->day_of_week->attributes()->data;
		$wetter[$i]['zustand'] = @$weather->condition->attributes()->data;
		$wetter[$i]['tiefsttemperatur'] = @$weather->low->attributes()->data;		
		$wetter[$i]['hoechsttemperatur'] = @$weather->high->attributes()->data;	
		$wetter[$i]['icon'] = @str_replace($icons_google, $icons_src, $weather->icon->attributes()->data);
	
		$i++;
	}
	
	return $wetter;
}

/*
END Version: 1.0.201106
*/

$user_town = $profile_fields_town;

// celsius/fahrenheit display
if ($celsius_or_fahrenheit == 0)
{
$c_f = ' F';
}
else
{
$c_f = ' &deg; C';
}

$user_town    = str_replace(' ', '-', $user_town);

// building weather array
$wetter = website_wetter(false, $user_town, false, $user_language, $script_pathes);

// first celsius/fahrenheit switch
if ($celsius_or_fahrenheit == 0)
{
$wetter[0]['temperatur'] = number_format(($wetter[0]['temperatur'] + 1) -1, 2, ',', ' ');
}
else if ($celsius_or_fahrenheit == 1)
{
$wetter[0]['temperatur'] = number_format(($wetter[0]['temperatur'] - 32) / 1.8, 2, ',', ' ');
}

// °C = (°F - 32) / 1.8
// °F = (°C * 1.8) + 32

        // weather details
		$template->assign_vars(array(
            'UW_CUR_LOCATION'  => ucwords($profile_fields_town),
	        'UW_CUR_STATUS'    => $wetter[0]['zustand'],
	        'UW_CUR_TEMP'      => $wetter[0]['temperatur'] . $c_f,
	        'UW_CUR_AIR_FL'    => $wetter[0]['luftfeuchtigkeit'],
	        'UW_CUR_WIND'      => $wetter[0]['wind'],
	        'UW_CUR_ICO'       => $script_pathes . $wetter[0]['icon'],	

			));		

// building weekday array			
$week_day_array = array(1,2,3,4);

// building weekdays
for ($i = 1; $i <= sizeof($week_day_array); $i++) {

// second celsius/fahrenheit switch
if ($celsius_or_fahrenheit == 0)
{
if ($user_language == 'en')
{
$wetter[$i]['tiefsttemperatur']  = number_format(($wetter[$i]['tiefsttemperatur'] + 1) - 1, 2, ',', ' ');
$wetter[$i]['hoechsttemperatur'] = number_format(($wetter[$i]['hoechsttemperatur'] + 1) - 1, 2, ',', ' ');
}
else
{
$wetter[$i]['tiefsttemperatur']  = number_format(($wetter[$i]['tiefsttemperatur'] * 1.8) + 32, 2, ',', ' ');
$wetter[$i]['hoechsttemperatur'] = number_format(($wetter[$i]['hoechsttemperatur'] * 1.8) + 32, 2, ',', ' ');
}
}

else if ($celsius_or_fahrenheit == 1)
{
if ($user_language == 'en')
{
$wetter[$i]['tiefsttemperatur']  = number_format(($wetter[$i]['tiefsttemperatur'] - 32) / 1.8, 2, ',', ' ');
$wetter[$i]['hoechsttemperatur'] = number_format(($wetter[$i]['hoechsttemperatur'] - 32) / 1.8, 2, ',', ' ');
}
else
{
$wetter[$i]['tiefsttemperatur']  = number_format(($wetter[$i]['tiefsttemperatur'] + 1) - 1, 2, ',', ' ');
$wetter[$i]['hoechsttemperatur'] = number_format(($wetter[$i]['hoechsttemperatur'] + 1) - 1, 2, ',', ' ');
}
}

// °C = (°F - 32) / 1.8
// °F = (°C * 1.8) + 32

		$template->assign_block_vars('user_weather', array(
	        'UW_WEEKDAY'   => $wetter[$i]['wochentag'],
	        'UW_CONDITION' => $wetter[$i]['zustand'],
			'UW_LOW'       => $wetter[$i]['tiefsttemperatur'] . $c_f,
			'UW_HIGH'      => $wetter[$i]['hoechsttemperatur'] . $c_f,
			'UW_CUR_ICO'   => $script_pathes . $wetter[$i]['icon']
			
			));
	}

}

else{

// no entry in map
$template->assign_var('S_USER_MAP_TRUE', false);

}

 // check cache, if old files are present(> 1 week)
 $dirs = $phpbb_root_path . 'user_weather/cache';
 $fileArray = array();
 foreach (glob($dirs."/*.xml") as $filen) 
 {
    $diffs = time() - filemtime($filen);

    if($diffs > 604800) // 1 week
    {
      unlink($filen);	  
    }
 }
 
 }
										   
// template output
$template->set_filenames(array(
'body' => 'user_weather.html'));

page_footer();

?>